
shader_node_categories = {
    "Shader": ["ShaderNodeBsdfDiffuse", "ShaderNodeBsdfPrincipled", "ShaderNodeEmission"],
    "Texture": ["ShaderNodeTexImage", "ShaderNodeTexNoise", "ShaderNodeTexChecker"],
    "Converter": ["ShaderNodeRGBToBW", "ShaderNodeMath", "ShaderNodeMixRGB"],
    "Input": ["ShaderNodeTexCoord", "ShaderNodeValue"],
    "Output": ["ShaderNodeOutputMaterial"]
}
BLEND_MODES = [
    ('MIX', 'Mix', 'Mix the layers'),
    ('PASS', 'Passthrough', 'Pass through'),
    (None),
    ('ADD', 'Add', 'Add the layers'),
    ('MULTIPLY', 'Multiply', 'Multiply the layers'),
    ('SUBTRACT', 'Subtract', 'Subtract the layers'),
    ('SCREEN', 'Screen', 'Screen the layers'),
    ('DIVIDE', 'Divide', 'Divide the layers'),
    (None),
    ('DIFFERENCE', 'Difference', 'Difference between the layers'),
    ('DARKEN', 'Darken', 'Darken the layers'),
    ('LIGHTEN', 'Lighten', 'Lighten the layers'),
    ('OVERLAY', 'Overlay', 'Overlay the layers'),
    ('DODGE', 'Dodge', 'Dodge the layers'),
    ('BURN', 'Burn', 'Burn the layers'),
    (None),
    ('HUE', 'Hue', 'Combine Hue of the layers'),
    ('SATURATION', 'Saturation', 'Combine Saturation of the layers'),
    ('VALUE', 'Value', 'Combine Value of the layers'),
    ('COLOR', 'Color', 'Combine Color of the layers'),
    ('SOFT_LIGHT', 'Soft Light', 'Soft light blending'),
    ('LINEAR_LIGHT', 'Linear Light', 'Linear light blending'),
    (None),
    ('COMBNRM', 'Combine Normal', 'Combine normal blending'),
]
TEXTURE_TYPE = [
    ('DIFFUSE', 'Diffuse', 'Texture as Diffuse'),
    ('METALLIC', 'Metallic', 'Texture as Metallic'),
    ('ROUGHNESS', 'Roughness', 'Texture as Roughness'),
    ('EMISSION', 'Emission', 'Texture as Emission'),
    ('ALPHA', 'Alpha', 'Texture as Alpha'),
    ('NORMAL', 'Normal', 'Texture as Normal'),
    ('HEIGHT', 'Height', 'Texture as Height'),
    ('AO', 'Ambient Occlusion', 'Texture as Ambient Occlusion'),
    ('CUSTOM', 'Custom', 'Custom texture'),
]
TEXTURE_FILTER = [
    ('Linear', 'Linear', ''),
    ('Closest', 'Closest', ''),
    ('Cubic', 'Cubic', ''),
    ('Smart', 'Smart', ''),
]
BAKE_TYPE = [
    ('AO', "Ambient Occlusion", ""),
    ('NORMAL',"Normal Map", ''),
    ('CURVATURE',"Curvature Map", ''),
    ('NRMOBJ',"Object Normal Map", ''),
    ('POSITION',"Object Position Map", ''),
    ('HEIGHT',"Height Map", ''),
    ('DIFFUSE', "Diffuse Map", ""),
    ('EMISSION', "Emission", ""),
]
SORT_COLORS = [
    ('PANEL_CLOSE', "", ""),
    ('SEQUENCE_COLOR_01', "", ""),
    ('SEQUENCE_COLOR_02', "", ""),
    ('SEQUENCE_COLOR_03', "", ""),
    ('SEQUENCE_COLOR_04', "", ""),
    ('SEQUENCE_COLOR_05', "", ""),
    ('SEQUENCE_COLOR_06', "", ""),
    ('SEQUENCE_COLOR_07', "", ""),
    ('SEQUENCE_COLOR_08', "", ""),
]
FOLDER_SORT_COLORS = [
    ('OUTLINER_COLLECTION', "", ""),
    ('COLLECTION_COLOR_01', "", ""),
    ('COLLECTION_COLOR_02', "", ""),
    ('COLLECTION_COLOR_03', "", ""),
    ('COLLECTION_COLOR_04', "", ""),
    ('COLLECTION_COLOR_05', "", ""),
    ('COLLECTION_COLOR_06', "", ""),
    ('COLLECTION_COLOR_07', "", ""),
    ('COLLECTION_COLOR_08', "", ""),
]
FILTERS = [
    ('PAINT', 'Paint Layer', 'ShaderNodeTexImage',"BRUSH_DATA",0),
    ('FILL', 'Fill Layer', 'ShaderNodeGroup',"IMAGE",0),
    (None),
    ('LEVELS', 'Levels', 'ShaderNodeGroup',"SEQ_HISTOGRAM",0),
    ('COLORRAMP', 'Color Ramp', 'ShaderNodeValToRGB',"COLORSET_10_VEC",0),
    ('CURVERGB', 'Curve', 'ShaderNodeRGBCurve',"NORMALIZE_FCURVES",0),
    ('HSV', 'HSV', 'ShaderNodeHueSaturation',"MOD_HUE_SATURATION",0),
    ('INVERT', 'Invert', 'ShaderNodeInvert',"MOD_MASK",0),
    ('GAMMA', 'Gamma', 'ShaderNodeGamma',"COLORSET_13_VEC",0),
    ('BRIGHTCONTRAST', 'Brightness Contrast', 'ShaderNodeBrightContrast',"COLORSET_10_VEC",0),
    (None),
    ('LIGHT', 'Light', 'ShaderNodeGroup',"SHADING_RENDERED",0),
    ('BLUR', 'Blur', 'ShaderNodeGroup',"PROP_OFF",0),
    ('SNAPSHOT', 'Snapshot', 'ShaderNodeGroup',"FCURVE_SNAPSHOT",0),
    (None),
    ('SEPARATERGB', 'Separate RGB', 'ShaderNodeSeparateRGB',"IMAGE_RGB_ALPHA",0),
    ('MASKCOLOR', 'Select Color', 'ShaderNodeGroup',"CLIPUV_DEHLT",0),
    ('MASKGEN', 'Mask Generator', 'ShaderNodeGroup',"NODE_TEXTURE",0),
    (None),
    ('CUSTOM', 'Custom Filter', 'ShaderNodeGroup',"NODETREE", 0),
]
MASKITEMS = [
    ('AO', "ShaderNodeAmbientOcclusion", "Color", 'ao_expand'),
    ('Curvature', "ShaderNodeAmbientOcclusion", "Color", 'curv_expand'),
    ('Position', "ShaderNodeTexCoord", "Generated", 'pos_expand'),
    ('Object Normal', "ShaderNodeNewGeometry", "Normal", 'objn_expand'),
]